; docformat = 'rst'

;+
; Convert a variable to a long integer.
; 
; :Returns:
;    long value (-1L if the string could not be converted)
;
; :Params:
;    x : in, required, type=string
;       string to be converted to a long
;
; :Keywords:
;    error : out, optional, type=boolean
;       set to a named variable to get the error status of the conversion
;-
function mg_long, x, error=error
  compile_opt strictarr
  on_ioerror, bad_conversion
  
  longint = long(x)
  
  error = 0B
  return, longint
  
  bad_conversion: 
  
  error = 1B
  return, -1L
end


; main-level example

help, mg_long('5.0', error=error), error
help, mg_long('not numeric', error=error), error

end

